"""
Plone Hotfix 2006-10-13

Modify theisMemberIdAllowed method of the membership tool to check for
groups with the same id. This fixes https://dev.plone.org/plone/ticket/5906
"""

from Products.CMFCore.permissions import AddPortalMember
from Products.CMFCore.utils import getToolByName
from Products.PluggableAuthService.interfaces.authservice \
        import IPluggableAuthService


def isMemberIdAllowed(self, id):
    if len(id) < 1 or id == 'Anonymous User':
        return 0
    if not self._ALLOWED_MEMBER_ID_PATTERN.match( id ):
        return 0

    pas = getToolByName(self, 'acl_users')
    if IPluggableAuthService.providedBy(pas):
        results = pas.searchPrincipals(id=id)
        if results:
            return 0
    else:
        membership = getToolByName(self, 'portal_membership')
        if membership.getMemberById(id) is not None:
            return 0
        groups = getToolByName(self, 'portal_groups')
        if groups.getGroupById(id) is not None:
            return 0

    return 1


from Products.CMFPlone.RegistrationTool import RegistrationTool
RegistrationTool.isMemberIdAllowed = isMemberIdAllowed
